# models.py
from database.database import db


class DownloadedFile(db.Model):
    id = db.Column(db.Integer, primary_key=True)
    name = db.Column(db.String(255), unique=True, nullable=False)
    path = db.Column(db.String(255), nullable=True)  # 允许 NULL 值
    downloaded = db.Column(db.Boolean, default=False, nullable=False)

    def __repr__(self):
        return f'<DownloadedFile {self.name}>'
