# config_manager.py
import configparser
import os


class ConfigManager:
    def __init__(self, config_path):
        self.config = configparser.ConfigParser()
        self.config.read(config_path)

    def get_value(self, section, option):
        return self.config.get(section, option)
